//**********Implementation file of header 1_4.h *********************/
// Author      : Oren Garten	
// Modify Date : 27/06/09				 
// Project     : 1_4
// Using       : iostream
//
// Description : Implementation of Question 1_4

/************** Library Includes *************/
#include <iostream>
//********************************************/

// Function    : DigitSum
// Description : calculates sum of a number's digits
//			     
// Input       : integer whose digits sum will be calculated  
// Returns	   : sum of the digits

int DigitSum(int x)
{
	int sum =0;
	unsigned char digit;
	
	while(x)
	{
		digit = x%10;
		sum += digit;
		x /=10;
	}
	
	return sum;

}


//----------------------------------------------
int main()
{
	int x;
	

	printf("Enter an integer:\n");
	scanf("%d",&x);
	
	printf("digit sum of %d is %d:\n",x,DigitSum(x));
	
	
	
	return 0;	
}