/**************** File Header ***************/
// Author      : Oren Garten	034298026
// Modify Date : 25/06/09				 
// Project     : 1_8
// Using       : iostream
// Description : Implementation of Question 1_8 



/************** Library Includes *************/
#include <iostream>

/**************** Declarations ***************/
// Struct      : 
// Description : 
// Fields      : next - pointer to the next node in the list
//				 data - the life points of the Enemy


// Function    : addNode
// Description : creates new node, assign the data to the node
//				 and add it to the end of the list
// Input       : pointer to the head of the list,
//				 pointer to the data
// Returns     : in case of success - pointer the Head of the List
//				 in case of failure - NULL 


//llnode* addNode(llnode *head, void* data);



// Function    : freeList
// Description : frees the list (frees allocated memory for each node)
//			     WARNING: the data member of the node won't be released
//						  because nothing is known of the structure of the data
//						  that may contain child objects that needed to be released as well
// Input       : list

//void freeList(llnode *head);

//---------------------------------

int main()
{
	int a,b,c,d;
	int hr, min,tot_min_passed;
//--------Getting arguments from user--------------------------
	do
	{
		printf("Enter First time hh:mm :\n"); 
		scanf("%d:%d",&a,&b);
		if(a>=24 || b>=60)
			printf("invalid time\n");
		else
			break;
	}
	while(1);

	do
	{
		printf("Enter second time hh:mm :\n"); 
		scanf("%d:%d",&c,&d);
		if(c>=24 || d>=60)
			printf("invalid time\n");
		else
			break;
	}
	while(1);
	
//-------------Calculating....-------------------------------------------
	
	printf("Calculating how much time passed between:\n");
	printf("%02d:%02d till %02d:%02d \n",a,b,c,d);   	
	
	if(c>=a)
	{
		hr = c-a;
	}
	else
	{
		hr = 24 + (c-a);
	}

	tot_min_passed = hr*60 + (d-b);//total diff[minutes]
	hr  = tot_min_passed/60;
	min = tot_min_passed%60;


	printf("Total time passed %02d:%02d\n",hr,min);
	return 0;
}