//**********Implementation file of header 2_1_19.h *********************/
// Author      : Oren Garten	
// Modify Date : 28/06/09				 
// Project     : 2_1_19
// Using       : iostream, math.h
//
// Description : Implementation of Question 2_1_19

/************** Library Includes *************/
#include <iostream>
#include <math.h>
//********************************************/

// Function    : special_sqrt
// Description : calculates sum of ques.2.1.19 given expression
//			     
// Input       : number of iterations to run the op  
// Returns	   : result

double special_sqrt(unsigned int times)
{
	double arg = 0; 
	
	while(times--)
		arg = sqrt(arg+2);

	return arg;
	
}

//----------------------------------------------
int main()
{
	unsigned int times;
	

	printf("Enter num of times to run special sqrt:\n");
	scanf("%d",&times);
	
	printf("expression result after %d run times is %lf:\n",times,special_sqrt(times));
	
	
	
	return 0;	
}