/**************** File Main of 3_1_2  ***************/
// Author      : Oren Garten	
// Modify Date : 30/06/09				 
// Project     : 3_1_2
// Using       : iostream,assert.h,ctime 
// Description : Implementation of Question 3_1_2 



/************** Library Includes *************/
#include <iostream>
#include <assert.h>
#include<ctime> //for rand()

#define  MAX_ARR_SIZE 100
/**************** Declarations ***************/
// Struct      : 
// Description : 
// Fields      : next - pointer to the next node in the list
//				 data - the life points of the Enemy




//---------------------------------
// Function    : max
// Description : return the idndex of the max element
//				 
// Input       : arr - the array for which max idx is searched
//				 size - number of elemnts in array arr
//				 
// Returns     : int - the idx of the max element

int max (int* arr, int size)
{
 	int maxItem = arr[0];
	int maxIdx = 0; 

	for(int i=0;i<size;i++)
	{
		maxIdx	= (arr[i] > maxItem)?i:maxIdx;
		maxItem = (arr[i] > maxItem)?arr[i] :maxItem;
	}	
	return maxIdx;
}
//---------------------------------
// Function    : display_arr
// Description : prints to screen array contents
//				 
// Input       : array of Type int be printed
//				 
// Returns     : void
//
void display_arr(int arr[MAX_ARR_SIZE])
{
	printf("arr[%d] content:\n",MAX_ARR_SIZE);
	printf("---------------------\n");
	
		for(int i=0; i<MAX_ARR_SIZE;i++)
			printf("%02d ",arr[i]);
	
	printf("\n");
	printf("---------------------\n");
}

//---------------------------------
int main()
{
	
	system("cls"); 
    srand(time(0));

	int arr[] = {-3,9,18,-7,11,6,-5,-22,3,2,-1};
	int n = sizeof(arr)/sizeof(int); 
	printf("MAX Element %d is at index: %d \n",arr[max(arr,n)] ,max(arr,n));
	return 0;
}