/**************** File Main of 3_1_6  ***************/
// Author      : Oren Garten	
// Modify Date : 05/07/09  			 
// Project     : 3_1_6
// Using       : iostream, assert.h, ctime, cmath 
// Description : Implementation of Question 3_1_6
//               Program goal is to find and display list of primes inside range [1:n] 



/************** Library Includes *************/
#include <iostream>
#include <assert.h>
#include <cmath> //for sqrt()
#include <ctime> //for rand()
#include <stdlib.h>
#include <algorithm>


typedef  unsigned int   Uint; 
typedef  unsigned short Ushort; 
typedef  unsigned char  Uchar; 

#define N 5
/**************** Declarations ***************/

//---------------------------------

// Struct      : SingleBit
// Description : stores 1 bit of memory
// Fields      : f0
typedef struct SingleBit
{
	Uchar f0:1 ;
}SingleBit;
//---------------------------------


int main()
{
	system("cls"); 
	srand(time(0));
	
	double arr[N] = {-1.1111, 4.222 , -5.999999, 3.98, 25.02};
	float temp, minDiff = 9999999;
	//seif A
	int i;

	for(i = 0; i<N ; i++)
	{
		if( ( arr[i]-(int)arr[i] ) == 0.0)
			printf("%.3f ",arr[i]);
	}
	printf("\n");
	
	//seif B
	int minIdx; 

	
	
	for(i = 0; i<N ; i++)
	{
		temp = fabs(arr[i]-int(arr[i]));
		temp = (temp > 1-temp )?1-temp : temp;
		if(temp <minDiff)
		{
			minDiff= temp;
			minIdx = i;
		}
	}

	printf("\nbest index: %f minDiff: %f \n",arr[minIdx], minDiff);  
	return 0;
}
