//**********Implementation file of header 6_20.h *********************/
// Author      : Oren Garten	
// Modify Date : 28/06/09				 
// Project     : 6_20
// Using       : iostream
//
// Description : Implementation of Question 6_20

/************** Library Includes *************/
#include <iostream>
#include "6_20.h"
//----------------------------------------------

seq max_seq(unsigned long x)
{
	
	int i = 0;
	int max_idx,curr_idx;
	int max_cnt,curr_cnt;

	int mask =1;
	seq res;

	
	max_idx = curr_idx = 0;
	max_cnt = curr_cnt = 0;
	
	if(~x == 0)//if x is 0xffffffff 
	{
		res.idx = 0;
		res.len = 32;
		return res;

	}
	
	for(i = 0;i<NUMofDIGITS;i++)
	{
		if( (x&mask)== 0 )//reached end of last ones sequence
		{
			max_idx =(curr_cnt>max_cnt)?curr_idx:max_idx;//update index if needed
			max_cnt =(curr_cnt>max_cnt)?curr_cnt:max_cnt;//update length if needed
			
			curr_cnt = 0;
			curr_idx = i+1;
		}
		else
		{
			curr_cnt++;// inc counter and keep on till reaching a '0'
		}

		mask <<=1;//scann bits from left to right	
	}


	res.idx = max_idx;	
	res.len = max_cnt;
	
	return res;

}


//----------------------------------------------

seq max_equal (unsigned long a, unsigned long b)
{
	unsigned long comp_vec = a^b;
	//all same bits of a and b are zero in comp_vec
	//all diff bits of a and b are one in comp_vec

	comp_vec =~comp_vec;
	//after inverting:
	//all same bits of a and b are one in comp_vec
	//all diff bits of a and b are zero in comp_vec

	//so all we need now is to find the maximum 1's sequence :

	return max_seq(comp_vec);
}