/**************** File Header ***************/
// Author      : Oren Garten	
// Modify Date : 28/06/09				 
// Project     : 6_20
// Using       : iostream
// Description : Implementation of Question 6_20



/************** Library Includes *************/
#include <iostream>
//---------------------------------------------
#ifndef _6_20_h
#define _6_20_h

#define NUMofDIGITS 32

/**************** Declarations ***************/
// Struct      : bit
// Description : a data type holding 1 bit memory
// Fields      : val - the value of the bit: 1 or 0  
//				 
typedef struct bit{
	bool	val :1;				
}bit;
//---------------------------------
// Struct      : seq
// Description : a data type holding sequence parameters
// Fields      : idx - the rightest index of the ones sequence
//				 len - the length of the sequence 
				 
typedef struct seq{
	int	idx;
	int len;		

}seq;
//---------------------------------
// Function    : max_seq
// Description : returns the longest 1's consecutive sequence inside a given number
//				 
// Input       : one number, in which the 1's sequence will be searched 
//				 
// Returns     : a struct containing all the necessary params' defining the sequence:
//				(index,length)  
//				  

seq max_seq(unsigned long a);
//---------------------------------
// Function    : max_equal
// Description : returns the longest sequence(index,length) of identical bits of 2 
//                given numbers.
//				 
// Input       : 2 integers a,b
//				 
// Returns     : a struct containing all the necessary params' defining the sequence:
//               (index,length)  
//				
seq max_equal(unsigned long a, unsigned long b);




#endif