/**************** File Main of 3_1_13  ***************/
// Author      : Oren Garten	
// Modify Date : 30/06/09				 
// Project     : 3_1_13
// Using       : iostream,assert.h,ctime,algorithm 
// Description : Implementation of Question 3_1_13 



/************** Library Includes *************/
#include <iostream>
#include <assert.h>
#include<ctime> //for rand()
#include<stdlib.h>
#include <algorithm>


typedef  unsigned int Uint;
#define  N 20
/**************** Declarations ***************/
//---------------------------------
// Function    : display_arr
// Description : prints to screen array contents
//				 
// Input       : array of Type int be printed
//				 
// Returns     : void
//
void display_arr(Uint arr[N])
{
	printf("arr[%d] content:\n",N);
	printf("---------------------\n");
	
		for(int i=0; i<N;i++)
			printf("%d ",arr[i]);
	
	printf("\n");
	printf("---------------------\n");
}
//---------------------------------
// Function    : swap
// Description : 
//				 
// Input       : 
//				 
// Returns     : void
//
void swap(Uint* a,Uint* b)
{
	Uint temp = *a;
	*a = *b;
	*b = temp;
}


//---------------------------------
int main()
{
	
	system("cls"); 
    srand(time(0));

	Uint arr[N],i,R; 
	
	//initialize array with 1,2,3...N
	for(i=0;i<N; i++)
		arr[i]= i+1;

	//display initial state
	display_arr(arr);
	
	//start permutating inside array, and display after each loop iteration
	for(i=N;i>1; i--)
	{
		R= rand()%(i-1);
		swap(&arr[i-1],&arr[R]);
		printf("%d# ",i);
		display_arr(arr);
	}

	return 0;
}