/**************** File Main of 3_2_4  ***************/
// Author      : Oren Garten	
// Modify Date : 05/07/09				 
// Project     : 3_2_4
// Using       : iostream,assert.h,ctime,algorithm 
// Description : Implementation of Question 3_2_4 



/************** Library Includes *************/
#include <iostream>
#include <assert.h>
#include<ctime> //for rand()
#include<stdlib.h>//for malloc/free/exit
#include <algorithm>


typedef  unsigned int Uint;
#define  N 6
/**************** Declarations ***************/
//---------------------------------
// Function    : display_arr
// Description : prints to screen array contents
//				 
// Input       : array of Type int be printed
//				 
// Returns     : void
//
void display_arr(Uint* arr, Uint n)
{
	printf("arr[%d] content:\n",N);
	printf("---------------------\n");
	
		for(int i=0; i<n;i++)
			printf("%d ",arr[i]);
	
	printf("\n");
	printf("---------------------\n");
}
//---------------------------------
// Function    : init
// Description : 
//				 
// Input       : array of Type Uint be initialized
//				 
// Returns     : void
//
void init(Uint* arr, Uint n)
{

		for(int i=0; i<n;i++)
			arr[i] = i;
	
}
//---------------------------------
// Function    : show_all_triples
// Description : 
//				 
// Input       : 
//				 
// Returns     : void
//
void show_all_triples(Uint* arr, Uint n)
{
	Uint i,j,k,sum=0;

	for(i=0;i<N; i++)
	{
		for(j=0;j<N;j++)
		{
			if(j==i)
				continue;
			else
			{
				for(k=0;k<N;k++)
				{
					if((k==i)||(k==j))
						continue;
					else
					{
						printf("arr[%d],arr[%d],arr[%d]\n",i,j,k);
						sum++;
					}
				}
			}

		}
	}
	printf("\ntotal: %d possibilities\n\n",sum);//expected sum = N!/(N-3)! 
}
//---------------------------------
// Function    : show_all_DiffPairs
// Description : 
//				 
// Input       : 
//				 
// Returns     : void
//
void show_all_DiffPairs(Uint* arr, Uint n)
{
	Uint i,j,sum=0;

	for(i=0;i<N; i++)
	{
		for(j=0;j<i;j++)
		{
			
			printf("arr[%d],arr[%d]\n",i,j);
			sum++;
		}
	}
			
	printf("\ntotal: %d possibilities\n\n",sum);//expected sum = N!/(2!*(N-2)!) 
}
//---------------------------------
// Function    : show_all_DiffTriples
// Description : 
//				 
// Input       : 
//				 
// Returns     : void
//
void show_all_DiffTriples(Uint* arr, Uint n)
{
	Uint i,j,k,sum=0;

	for(i=0;i<N; i++)
	{
		for(j=0;j<i;j++)
		{
			for(k=0; k<i && k<j ;k++)
			{
				printf("arr[%d],arr[%d],arr[%d]\n",i,j,k);
				sum++;
			}
		}
	}
			
	printf("\ntotal: %d possibilities\n\n",sum);//expected sum = N!/(3!*(N-3)!) 
}
//---------------------------------
int main()
{
	
	system("cls"); 
    srand(time(0));

	Uint arr[N];
	
	//initialize array with 1,2,3...N
	init(arr,N);
	
	//seif A
	show_all_triples(arr, N);
	
	//seif B
	show_all_DiffPairs(arr, N);

	//seif C
	show_all_DiffTriples(arr, N);

	
	
	return 0;
}